%define _buildid .13

%global py26nvr python26-urlgrabber-%{version}-%{release}
%global py26builddir %{_builddir}/%{py26nvr}
%global py26doc ../%{py26nvr}

%global py27nvr python27-urlgrabber-%{version}-%{release}
%global py27builddir %{_builddir}/%{py27nvr}
%global py27doc ../%{py27nvr}

%bcond_without tests # with

%global upstream_name urlgrabber

Name: python-urlgrabber
Version: 3.9.1
Release: 9%{?_buildid}%{?dist}
Summary: A high-level cross-protocol url-grabber
Group: Development/Libraries
License: LGPLv2+
URL: http://urlgrabber.baseurl.org/
Source0: urlgrabber-%{version}.tar.gz
Patch1: urlgrabber-HEAD.patch
Patch2: BZ-604724-urlgrabber-basename+options.patch
# Holding BZ 695747
Patch3: curl-workarounds.patch
Patch10: urlgrabber-3.9.1-py24.patch
# RHEL-6.5 fast
Patch11: BZ-807030-error-timestamp-typo.patch
BuildArch: noarch
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildRequires: python26
BuildRequires: python27

%description
A high-level cross-protocol url-grabber for python supporting HTTP, FTP 
and file locations.  Features include keepalive, byte ranges, throttling,
authentication, proxies and more.

%package -n python26-urlgrabber
Summary: A high-level cross-protocol url-grabber
BuildRequires: python26-devel
BuildRequires: python26-pycurl
Requires: python26(alternatives)
Requires: alternatives(addslave)
Requires: alternatives(removeslave)
Requires: alternatives(force)
Requires(preun): python26(alternatives)
Requires(preun): alternatives(removeslave)
Requires: python26-pycurl
Provides: python-urlgrabber = %{version}-%{release}
Provides: urlgrabber = %{version}-%{release}
Obsoletes: python-urlgrabber <= 3.9.1-9.10.amzn1

%description -n python26-urlgrabber
A high-level cross-protocol url-grabber for python supporting HTTP, FTP 
and file locations.  Features include keepalive, byte ranges, throttling,
authentication, proxies and more.

This package is meant to be used with Python 2.6.

%package -n python27-urlgrabber
Summary: A high-level cross-protocol url-grabber
BuildRequires: python27-devel
BuildRequires: python27-pycurl
Requires: python27(alternatives)
Requires: alternatives(addslave)
Requires: alternatives(removeslave)
Requires: alternatives(force)
Requires(preun): python27(alternatives)
Requires(preun): alternatives(removeslave)
Requires: python27-pycurl
Conflicts: python-urlgrabber <= 3.9.1-9.10.amzn1

%description -n python27-urlgrabber
A high-level cross-protocol url-grabber for python supporting HTTP, FTP 
and file locations.  Features include keepalive, byte ranges, throttling,
authentication, proxies and more.

This package is meant to be used with Python 2.7.

%prep
%setup -q -n %{upstream_name}-%{version}
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch10 -p1
%patch11 -p1

%build
rm -rf %{py26builddir}
mkdir -p %{py26builddir}
cp -a * %{py26builddir}
pushd %{py26builddir}
CFLAGS="$RPM_OPT_FLAGS" %{__python26} setup.py build 
popd

rm -rf %{py27builddir}
mkdir -p %{py27builddir}
cp -a * %{py27builddir}
pushd %{py27builddir}
CFLAGS="$RPM_OPT_FLAGS" %{__python27} setup.py build 
popd

%install
rm -rf %{buildroot}

pushd %{py26builddir}
%{__python26} setup.py install -O1 --skip-build --root %{buildroot} --install-layout=amzn
popd
rm -rf %{buildroot}%{_docdir}/urlgrabber-%{version}
mv %{buildroot}%{_bindir}/{urlgrabber,urlgrabber-2.6}

pushd %{py27builddir}
%{__python27} setup.py install -O1 --skip-build --root %{buildroot} --install-layout=amzn
popd
rm -rf %{buildroot}%{_docdir}/urlgrabber-%{version}
mv %{buildroot}%{_bindir}/{urlgrabber,urlgrabber-2.7}

%check
%if %{with tests}
%endif

%clean
rm -rf %{buildroot}
rm -rf %{py26builddir}
rm -rf %{py27builddir}

%triggerin -n python26-urlgrabber -- python26
# Refresh alternatives when updating python26-urlgrabber or python26.
%{_sbindir}/update-alternatives \
  --force \
  --update python %{_bindir}/python2.6 \
  --addslave %{_bindir}/urlgrabber urlgrabber %{_bindir}/urlgrabber-2.6 \
  || :

%preun -n python26-urlgrabber
if [ $1 -eq 0 ]; then
  %{_sbindir}/update-alternatives \
    --update python %{_bindir}/python2.6 \
    --removeslave urlgrabber \
 || :
fi

%triggerin -n python27-urlgrabber -- python27
# Refresh alternatives when updating python27-urlgrabber or python27.
%{_sbindir}/update-alternatives \
  --force \
  --update python %{_bindir}/python2.7 \
  --addslave %{_bindir}/urlgrabber urlgrabber %{_bindir}/urlgrabber-2.7 \
  || :

%preun -n python27-urlgrabber
if [ $1 -eq 0 ]; then
  %{_sbindir}/update-alternatives \
    --update python %{_bindir}/python2.7 \
    --removeslave urlgrabber \
 || :
fi

%files -n python26-urlgrabber
%doc ChangeLog LICENSE README TODO
%{python26_sitelib}/*
%{_bindir}/urlgrabber-2.6
%ghost %{_bindir}/urlgrabber

%files -n python27-urlgrabber
%doc ChangeLog LICENSE README TODO
%{python27_sitelib}/*
%{_bindir}/urlgrabber-2.7
%ghost %{_bindir}/urlgrabber

%changelog
* Fri Feb 27 2015 Ben Cressey <bcressey@amazon.com>
- add alternatives for urlgrabber

* Tue Feb 3 2015 Ben Cressey <bcressey@amazon.com>
- build for multiple pythons

* Tue Jul 30 2013 Cristian Gafton <gafton@amazon.com>
- import source package RHEL6/python-urlgrabber-3.9.1-9.el6

* Wed May 29 2013 James Antill <james@fedoraproject.org> 3.9.1-9
- Fix a typo when raising the error for setting timestamp.
- Resolves: rhbz#807030

* Sun May 22 2011 Cristian Gafton <gafton@amazon.com>
- import source package RHEL6/python-urlgrabber-3.9.1-8.el6

* Tue Apr 12 2011 James Antill <james@fedoraproject.org> 3.9.1-8
- Work around some problems in curl.
- Resolves: rhbz#695747

* Fri Dec 17 2010 Cristian Gafton <gafton@amazon.com> - 3.9.1-7
- add patch to allow building under python 2.4

* Fri Dec 17 2010 Cristian Gafton <gafton@amazon.com>
- add patch to allow building under Python 2.4

* Thu Dec 2 2010 Cristian Gafton <gafton@amazon.com>
- import source package RHEL6/python-urlgrabber-3.9.1-7.el6

* Wed Jul 14 2010 James Antill <james@fedoraproject.org> 3.9.1-7
- Fix automatic basename for downloads, and -o option problems.
- Resolves: rhbz#604724

* Fri Jul 9 2010 Cristian Gafton <gafton@amazon.com>
- import source package RHEL6/python-urlgrabber-3.9.1-6.el6
- import source package RHEL6/python-urlgrabber-3.9.1-4.el6

* Fri May 7 2010 Cristian Gafton <gafton@amazon.com>
- import source package RHEL5/python-urlgrabber-3.1.0-5.el5
- import source package RHEL5/python-urlgrabber-3.1.0-2
- added submodule prep for package python-urlgrabber

* Tue Apr 13 2010 James Antill <james@fedoraproject.org> 3.9.1-6
- Update to upstream HEAD.
- LOWSPEEDLIMIT and hdrs
- Resolves: rhbz#576708

* Fri Feb 19 2010 Seth Vidal <skvidal at fedoraproject.org> - 3.9.1-5
- add patch to allow reset_curl_obj() to close and reload the cached curl obj

* Thu Nov 12 2009 Seth Vidal <skvidal at fedoraproject.org> - 3.9.1-4
- reset header values when we redirect and make sure debug output will work

* Wed Nov 11 2009 Seth Vidal <skvidal at fedoraproject.org> - 3.9.1-3
- fixing a bunch of redirect and max size bugs

* Fri Sep 25 2009 Seth Vidal <skvidal at fedoraproject.org> - 3.9.1-2
- stupid patch

* Fri Sep 25 2009 Seth Vidal <skvidal at fedoraproject.org> - 3.9.1-1
- 3.9.1

* Tue Aug 18 2009 Seth Vidal <skvidal at fedoraproject.org> - 3.9.0-8
- ssl options, http POST string type fixes

* Mon Aug 10 2009 Seth Vidal <skvidal at fedoraproject.org> - 3.9.0-6
- reget fixes, tmpfiles no longer made for urlopen() calls.

* Wed Aug  5 2009 Seth Vidal <skvidal at fedoraproject.org> - 3.9.0-5
- apply complete patch to head fixes: timeouts, regets, improves exception raising

* Tue Aug  4 2009 Seth Vidal <skvidal at fedoraproject.org> - 3.9.0-4
- timeout patch for https://bugzilla.redhat.com/show_bug.cgi?id=515497

* Thu Jul 30 2009 Seth Vidal <skvidal at fedoraproject.org> - 3.9.0-1
- new version - curl-based

* Wed Apr  8 2009 James Antill <james@fedoraproject.org> 3.0.0-15
- Fix progress bars for serial consoles.
- Make C-c behaviour a little nicer.

* Fri Mar 13 2009 Seth Vidal <skvidal at fedoraproject.org>
- kill deprecation warning from importing md5 if anyone uses keepalive

* Mon Mar  9 2009 Seth Vidal <skvidal at fedoraproject.org>
- apply patch for urlgrabber to properly check file:// urls with the checkfunc

* Thu Feb 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 3.0.0-12
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Fri Nov 28 2008 Ignacio Vazquez-Abrams <ivazqueznet+rpm@gmail.com> 3.0.0-11
- Rebuild for Python 2.6

* Wed Oct 14 2008 James Antill <james@fedoraproject.org> 3.0.0-10
- Have the progress bar have a small bar, for a virtual size doubling.

* Thu Jul 10 2008 James Antill <james@fedoraproject.org> 3.0.0-9
- Make urlgrabber usable if openssl is broken
- Relates: bug#454179

* Sun Jun 15 2008 James Antill <james@fedoraproject.org> 3.0.0-9
- Don't count partial downloads toward the total

* Sat May 18 2008 James Antill <james@fedoraproject.org> 3.0.0-8
- Tweak progress output so it's hopefully less confusing
- Add dynamic resizing ability to progress bar
- Resolves: bug#437197

* Fri May  2 2008 James Antill <james@fedoraproject.org> 3.0.0-7
- Fix reget's against servers that don't allow Range requests, also tweaks
- reget == check_timestamp, if anyone/thing uses that.
- Resolves: bug#435156
- Fix minor typo in progress for single instance.

* Mon Apr  7 2008 James Antill <james@fedoraproject.org> 3.0.0-6
- Fix the ftp byterange port problem:
- Resolves: bug#419241
- Fixup the progress UI:
-   add function for total progress
-   add total progress percentagee current download line
-   add rate to current download line
-   use dead space when finished downloading
-   don't confuse download rate on regets.

* Sat Mar 15 2008 Robert Scheck <robert@fedoraproject.org> 3.0.0-5
- Make sure, that *.egg-info is catched up during build

* Mon Dec  3 2007 Jeremy Katz <katzj@redhat.com> - 3.0.0-4
- Ensure fds are closed on exceptions (markmc, #404211)

* Wed Oct 10 2007 Jeremy Katz <katzj@redhat.com> - 3.0.0-3
- fix type checking of strings to also include unicode strings; fixes 
  regets from yum (#235618)

* Mon Aug 27 2007 Jeremy Katz <katzj@redhat.com> - 3.0.0-2
- fixes for package review (#226347)

* Thu May 31 2007 Jeremy Katz <katzj@redhat.com> - 3.0.0-1
- update to 3.0.0

* Wed Dec  6 2006 Jeremy Katz <katzj@redhat.com> - 2.9.9-5
- rebuild for python 2.5

* Wed Dec  6 2006 Jeremy Katz <katzj@redhat.com> - 2.9.9-4
- fix keepalive (#218268)

* Sat Nov 11 2006 Florian La Roche <laroche@redhat.com>
- add version/release to "Provides: urlgrabber"

* Mon Jul 17 2006 James Bowes <jbowes@redhat.com> - 2.9.9-2
- Add support for byte ranges and keepalive over HTTPS

* Wed Jul 12 2006 Jesse Keating <jkeating@redhat.com> - 2.9.9-1.1
- rebuild

* Tue May 16 2006 Jeremy Katz <katzj@redhat.com> - 2.9.9-1
- update to 2.9.9

* Tue Mar 14 2006 Jeremy Katz <katzj@redhat.com> - 2.9.8-2
- catch read errors so they trigger the failure callback.  helps catch bad cds

* Wed Feb 22 2006 Jeremy Katz <katzj@redhat.com> - 2.9.8-1
- update to new version fixing progress bars in yum on regets

* Fri Dec 09 2005 Jesse Keating <jkeating@redhat.com>
- rebuilt

* Wed Sep 21 2005 Jeremy Katz <katzj@redhat.com> - 2.9.6-4
- don't use --record and list files by hand so that we don't miss 
  directories (#158480)

* Wed Sep 14 2005 Jeremy Katz <katzj@redhat.com> - 2.9.6-3
- add directory to file list (#168261)

* Fri Jun 03 2005 Phil Knirsch <pknirsch@redhat.com> 2.9.6-2
- Fixed the reget method to actually work correctly (skip completely transfered
  files, etc)

* Tue Mar  8 2005 Jeremy Katz <katzj@redhat.com> - 2.9.6-1
- update to 2.9.6

* Mon Mar  7 2005 Jeremy Katz <katzj@redhat.com> - 2.9.5-1
- import into dist
- make the description less of a book

* Mon Mar  7 2005 Seth Vidal <skvidal@phy.duke.edu> 2.9.5-0
- 2.9.5

* Thu Feb 24 2005 Seth Vidal <skvidal@phy.duke.edu> 2.9.3-0
- first package for fc3
- named python-urlgrabber for naming guideline compliance
